precision highp float;

varying vec3 vPosition;
varying vec3 vNormal;

uniform float time;
uniform float displacementFactor;

void main() {
    vPosition = position;
    vNormal = normalize((modelViewMatrix * vec4(normal, 0.0)).xyz);

    // Enhanced displacement calculation for a more "glitchy" and dynamic effect
    float displacement = displacementFactor * (sin(time + position.x * 10.0) + cos(time + position.y * 10.0));
    vec3 displacedPosition = position + normal * displacement;

    gl_Position = projectionMatrix * modelViewMatrix * vec4(displacedPosition, 1.0);
}
